#include <bits/stdc++.h>
using namespace std;

using DPVal = int;
const int N = 1e4;
const int M = 1e3;
const int D = 1e2;
const int INF = 1e9+7;

vector<vector<DPVal>> dp;

// for compiling as preC++17
struct string_view {
    char * str;
    int    len;
    string_view(char * str, int len) : str(str), len(len) { }
    string_view(const string & s) { str = const_cast<char*>(s.c_str()); len = s.size(); }
    char operator[](int index) { return str[index]; }
    int size() { return len; }
    string_view substr(int pos) { return string_view{ str + pos, len - pos }; }
    friend ostream & operator<<(ostream & os, const string_view & sv) { return os << sv.str; }
};

// Operace přidat / odebrat písmenko, změnit číslici X na libolných X písmenek

int solve(string_view a, string_view b) {
    auto & res = dp.at(a.size()).at(b.size());
    if (res == -1) {
        res = INF;
        // match
        if (a.size() && b.size() && (a[0] == '.' || b[0] == '.' || a[0] == b[0]))
            res = min(res, solve(a.substr(1), b.substr(1)));
        // delete letter
        if (a.size())
            res = min(res, solve(a.substr(1), b) + 1);
        // insert letter
        if (b.size())
            res = min(res, solve(a, b.substr(1)) + 1);
    }
    // cout << ">" << a << "< >" << b << "< " << res << endl;
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    string at, bt, a, b;
    assert(getline(cin, at));
    assert(getline(cin, bt));
    assert(at.size() > 0 && at.size() <= N);
    assert(bt.size() > 0 && bt.size() <= M);
    assert(count_if(begin(at), end(at), [] (char c) { return isdigit(c); }) <= D);
    assert(count_if(begin(bt), end(bt), [] (char c) { return isdigit(c); }) <= D);
    assert((uint64_t)at.size() * bt.size() <= 1e7);
    int res = count_if(begin(at), end(at), [] (char c) { return isdigit(c); }) + 
              count_if(begin(bt), end(bt), [] (char c) { return isdigit(c); });
    for (char c : at) {
        if (isdigit(c))
            a += string(c - '0', '.');
        else
            a += c;
    }
    for (char c : bt) {
        if (isdigit(c))
            b += string(c - '0', '.');
        else
            b += c;
    }
    dp = vector<vector<DPVal>> (a.size()+1, vector<DPVal>(b.size()+1, -1));
    dp[0][0] = 0;
    auto tmp = solve(a, b);
    assert(tmp != INF);
    res += tmp;
    cout << res << endl;
    return 0;
}
