import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2019
 * Sample Solution: Beer Matathon
 * 
 * @author Martin Kacer
 */
public class MarathonSimple {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new MarathonSimple().run();
	}
	
	void run() {
		int n = nextInt(), k = nextInt();
		int[] point = new int[n];
		long[] move = new long[n];
		for (int i = 0; i < n; ++i) point[i] = nextInt();
		Arrays.sort(point);
		for (int i = 0; i < n; ++i)
			move[i] = i*(long)k - point[i];
		Arrays.sort(move);
		long start = - move[n/2], sum = 0;
		for (int i = 0; i < n; ++i)
			sum += Math.abs((start + i*(long)k) - point[i]);
		System.out.println(sum);
	}
}
