import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2019
 * Sample Solution: Beer Matathon
 * 
 * @author Martin Kacer
 */
public class pytle {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new pytle().run();
	}
	
	static final int START0 = 1_000_000;
	
	int[] point;
	long[] move;
	long start;
	
	void run() {
		int n = nextInt(), k = nextInt();
		point = new int[n];
		move = new long[n];
		for (int i = 0; i < n; ++i) point[i] = nextInt();
		Arrays.sort(point);
		start = START0;
		long sum = 0;
		for (int i = 0; i < n; ++i)
			sum += (move[i] = (start += k) - point[i]);
		Arrays.sort(move);
		if (move[0] < 0) throw new IllegalStateException("too low value of START0");
		long best = sum, act = 0;
		for (int idx = 0; idx <= n/2; ++idx) {
			if (move[idx] == act) continue; // no move
			sum += (2*idx-n) * (move[idx]-act);  // + IDX - (n-IDX)
			act = move[idx];
			if (sum < best) best = sum;
		}
		System.out.println(best);
	}
}
