#include <bits/stdc++.h>
using namespace std;
using ii = pair<int,int>;
#define F(i,a,b) for (int i = (int)(a); i < (int)(b); ++i)

const int GRASS_TIMER =  3;
const int SHEEP_TIMER =  5;
const int WOLF_TIMER  = 10;

void printState(const vector<string> & board, const vector<vector<int>> & grass, const vector<vector<int>> & hunger) {
  int rows = board.size();
  int cols = board[0].size();
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (board[r][c] != '.')
        cout << board[r][c];
      else if (grass[r][c] < 0)
        cout << "*";
      else if (grass[r][c] >= GRASS_TIMER)
        cout << "#";
      else
        cout << ".";
    }
    cout << endl;
  }
}

void makeMove(vector<string> & board, vector<vector<int>> & grass, vector<vector<int>> & hunger) {
  int rows = board.size();
  int cols = board[0].size();
  vector<string> newBoard(rows, string(cols, '.'));
  auto newGrass = grass;
  vector<vector<int>> newHunger(rows, vector<int>(cols));
  // move sheep
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (board[r][c] == 'S') {
        newHunger[(r+1)%rows][c] = hunger[r][c];
        newBoard [(r+1)%rows][c] = 'S';
      }
    }
  }
  // move wolves
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (board[r][c] == 'W') {
        newHunger[r][(c+1)%cols] = hunger[r][c];
        if (newBoard[r][(c+1)%cols] == 'S') {
          // eat sheep
          newGrass [r][(c+1)%cols] = -1e9;
          newHunger[r][(c+1)%cols] = -1;
        }
        newBoard[r][(c+1)%cols] = 'W';
      }
    }
  }
  // eat grass
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (newBoard[r][c] == 'S' && newGrass[r][c] >= GRASS_TIMER) {
        newHunger[r][c] = -1;
        newGrass [r][c] = -1;
      }
    }
  }
  // grow hunger
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (newBoard[r][c] == 'S' || newBoard[r][c] == 'W')
        ++newHunger[r][c];
    }
  }
  // die of hunger
  F(r, 0, rows) {
    F(c, 0, cols) {
      if (newBoard[r][c] == 'S' && newHunger[r][c] >= SHEEP_TIMER) {
        newGrass [r][c] = -1e9;
        newHunger[r][c] = 0;
        newBoard [r][c] = '.';
      }
      if (newBoard[r][c] == 'W' && newHunger[r][c] >= WOLF_TIMER) {
        newGrass [r][c] = -1e9;
        newHunger[r][c] = 0;
        newBoard [r][c] = '.';
      }
    }
  }
  // grow grass
  F(r, 0, rows) {
    F(c, 0, cols) {
      ++newGrass[r][c];
    }
  }
  swap(board, newBoard);
  swap(grass, newGrass);
  swap(hunger, newHunger);
}

int main() {
  int turns, rows, cols;
  cin >> turns >> rows >> cols;
  vector<string> board(rows);
  for (auto & row : board)
    cin >> row;

  vector<vector<int>> grass (rows, vector<int>(cols));
  vector<vector<int>> hunger(rows, vector<int>(cols));
  while (turns--) {
    // printState(board, grass, hunger);
    // cout << endl;
    makeMove(board, grass, hunger);
  }
  printState(board, grass, hunger);
  cout << endl;
  
  return 0;
}