import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2019
 * Sample Solution: Six-Pack
 * 
 * @author Martin Kacer
 */
public class sixpack {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new sixpack().run();
	}

	static final int MOD = 1_000_000_007, MAX = 10;
	int len, sum, count, combFix;
	int[][] pack;
	int[][] comb = new int[3][2*MAX+1];
	
	int mod(long num) { return (int) (num % MOD); }
	
	void run() {
		len = nextInt(); sum = nextInt() + 6; int m = nextInt();
		pack = new int[2][len];
		for (int i = 0; i < m; ++i) {
			int c = nextInt(), r = nextInt(), v = nextInt();
			pack[r][c] = v + 1;
		}
		for (int s = 2; s <= 2*MAX; ++s)
			for (int o = 0; o < 3; ++o) {
				comb[o][s] = 1;
				for (int i = o; i < len && comb[o][s] > 0; i += 3)
					comb[o][s] = mod((long) comb[o][s] * possib(i, s));
			}
		long res = 0;
		for (int s1 = 2; s1 <= 2*MAX; ++s1)
			for (int s2 = 2; s2 <= 2*MAX; ++s2) {
				int s3 = sum - s1 - s2;
				if (s3 < 2 || s3 > 2*MAX) continue;
				res += mod((long) comb[0][s1] * comb[1][s2] * comb[2][s3]);
			}
		System.out.println(mod(res));
	}
	
	int possib(int idx, int s) {
		int p1 = pack[0][idx], p2 = pack[1][idx];
		if (p1 > 0 && p2 > 0) return (p1+p2 == s) ? 1 : 0;
		if (p1 > 0 || p2 > 0) return (s - p1 - p2 >= 1 && s - p1 - p2 <= MAX) ? 1 : 0;
		return (s <= MAX) ? s-1 : MAX*2 - s + 1;
	}
}
//